﻿using PComm;
using PObject;
using PUtility;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ClientForm
{
	public partial class MainForm : Form
	{
		private PClient heartBeatClient;
		private PClient client;

		private System.Timers.Timer heartBeatTimer;

		public MainForm()
		{
			InitializeComponent();
			InitInstance();
		}

		private void InitInstance()
		{
			heartBeatClient = new PClient("127.0.0.1", 7778);
			heartBeatClient.OnReceived += HeartBeatClient_OnReceived;

			client = new PClient("127.0.0.1", 7777);
			client.OnReceived += Client_OnReceived;

			heartBeatTimer = new System.Timers.Timer();
			heartBeatTimer.Interval = 5000;
			heartBeatTimer.Elapsed += HeartBeatTimer_Elapsed;
			heartBeatTimer.Start();
		}


		private void WriteLog(string log)
		{
			if (this.InvokeRequired)
			{
				Invoke((MethodInvoker)delegate () { WriteLog(log); });
			}
			else
			{
				logConsole.AppendText($"[{DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")}] {log}" + Environment.NewLine);
				PUtil.ScrollToEnd(logConsole);
			}
		}

		private void HeartBeatTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			heartBeatClient.Send("heartbeat");
		}

		private void HeartBeatClient_OnReceived(PClient sender, byte[] data)
		{
			string msg = Encoding.UTF8.GetString(data, 0, data.Length);
			if (msg != "good")
			{
				msg = "WARNING!!! BAD HEARTBEAT!!!";
			}

			WriteLog(msg);
		}

		private void Client_OnReceived(PClient sender, byte[] data)
		{
			throw new NotImplementedException();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			Person person = new Person()
			{
				Name = "Kim",
				Age = 35
			};

			byte[] data = PSerializer.Serialize(person);
			client.Send(data);
			
		}
	}
}
